	cpu	z80undoc
;
;HDISK45 Z1013-MEGA-Modul
;Volker Pohlers, Sanitz, 24.11.2011
;nach Rainer Brosig's HEADERDISK 45
;
;letzte Aenderung: 
; 16.02.2017 	kleine Korrektur, damit bei @R auch Filenummern > 255 gehen
;
;
SOIL:	EQU	00016H
ARG1:	EQU	0001BH
ARG2:	EQU	0001DH
ARG3:	EQU	00023H
CUPOS:	EQU	0002BH
RST38:	EQU	00038H
USRKD:	EQU	000B0H
AADR:	EQU	000E0H
EADR:	EQU	000E2H
SADR:	EQU	000E4H
HEAD:	EQU	000E6H
TYP:	EQU	000ECH
SIGNS:	EQU	000EDH
NAME:	EQU	000F0H
;
OUTCH:	EQU	000E7H
INCH:	EQU	001E7H
PRST7:	EQU	002E7H
OUTHX:	EQU	006E7H
;
CR:	EQU	0DH
;
bankport		equ	0ffh		; Portadresse Modul
;
	ORG	0BC00H
;
; Headersave/Headerdisk-kompatible Einsprungstabelle

	JP	LORUF		;File laden
	JP	NOSAV		;File saven
READ:	JP	LOAD		;File laden mit Typabfrage
WRITE:	JP	NOSAV		;File saven mit Typabfrage
	JP	BLMK		;Block lesen
	JP	NOSAV		;Block schreiben
	JP	SUCHK		;Kopfblock suchen
	JP	NOSAV		;Kopfpuffer aufbereiten
	JP	NOSAV		;Disk loeschen
init:	JP	ZMINI		;Z-Kdos initialisieren
FILES:	JP	FILE		;Files auflisten
;
;
;**************************************
;Anzeige aller Files auf Disk
;**************************************
;
FILE:	ld	hl,FIL4
	push	hl		; neue RET-Adr.

	LD	A,CR
	DW	OUTCH
;
	CALL	FFIRST		;File suchen
	CALL	C, NOFIL	;wenn Disk leer
	RET	C
;
	LD	HL,1		;Filezaehler
FIL2a:	ld	b,20
;Fileanzeige
FIL2:	push	bc
	CALL	FLDAT		;Anzeige Filedaten
	CALL	FNEXT		;folgt noch ein File?
	pop	bc
	RET	C		;wenn nicht
	LD	HL,(FILNR)
	INC	HL		;Fileanzahl erhoehen
	
fil0:	djnz	fil2
	DW	INCH		;Warten auf Tastendruck
	cp	3		;ende bei STOP
	ret	z
FIL3:	JR	FIL2a
;abschliessen
FIL4:	call	home
	RET
;
;Anzeige Filedaten
;
FLDAT:	LD	(FILNR),HL	;Filenummer merken
	LD	DE,STPUF
	ld	a,3
	CALL	NRKON		;und in String schreiben
	LD	A,' '
	LD	(DE),A
	INC	DE
;
	CALL	STNAM		;Typ und Name eintragen
	LD	A,' '
	LD	(DE),A
	INC	DE
;
	LD	HL,(AADR)
	CALL	HLKON
	CALL	FLLEN		;Filelaenge eintragen
;
	LD	A,CR
	LD	(DE),A
	INC	DE
	XOR	A
	LD	(DE),A
;
	LD	DE,STPUF
	CALL	OSTRG		;und alles anzeigen
	RET
;
;Kdo-Kennbuchstaben "@XAB" holen
;
GETKB:	LD	HL,(SOIL)	;Beginn Eingabezeile
	INC	HL		; 'X'
	INC	HL		; 'A'
	INC	HL		; 'B'
	LD	A,(HL)		;3. Buchstabe nach IYL
	LD 	IYL,A
	DEC	HL		;2. Buchstabe nach A
	LD 	IYU,0
	LD	A,(HL)
	RET
;
;**************************************
;File laden @R @RN @RNX
;**************************************
;
LOAD:	CALL	GETKB		;
;
LORUF:	CALL	INFIL		;File auswaehlen
	RET	C		;wenn Fehler
	CALL	FLOAD		;File laden
	call	home
	LD	A,(TYP)
	CP	A, 'C'		;ist File selbstartend?
	RET	NZ		;nein --> zurueck
	LD 	A,IYL
	CP	A, ' '		;ist Selbstart freigegeben?
	RET	NZ		;nein --> zurueck
	LD	HL,(SADR)
	JP	(HL)		;Programmstart
;
;File auswaehlen
;
INFIL:	CP	A, 'N'		;Namenabfrage?
	JR	NZ, INFI1	;wenn nicht
	CALL	FIND		;suchen nach Namen
	ret	c	; bei fehler
	jr	infil0
;
INFI1:	CALL	NZ, INNR	;sonst Eingabe der Filenummer
INFI2:	RET	C		;Fehler bei der Eingabe
;
	PUSH	HL		;HL=Filenummer
	CALL	SUCHK		;File suchen
	POP	HL
	JP	C, FNOTX	;wenn nicht gefunden
;
infil0:	PUSH	HL
	LD	HL,(ARG1)	;evtl. neue Ladeadresse
	XOR	A		;angegeben?
	OR	H		;Wert <100H ?
	JR	Z, INFI3	;ja -->
;
	LD 	IYL,0		;Selbstart verbieten
;
	LD	BC,(AADR)	;Adressen umrechnen
	LD	(AADR),HL
	SBC	HL,BC
	LD	BC,(EADR)
	ADD	HL,BC
	LD	(EADR),HL
;
INFI3:	POP	HL		;und Fileangaben anzeigen
	CALL	STFIL
	LD	DE,STPUF
	CALL	OSTRG
	OR	A
	RET
;
;**************************************
;Kopfblock suchen neu HL = Nr !!!
;**************************************
;
SUCHK:	DEC	HL
	PUSH	HL
	CALL	FFIRST		;erstes File suchen
	POP	HL
	RET	C		;wenn nichts gefunden
	LD	A,H
	OR	L		;gleich das erste File?
	RET	Z		;ja
;
				;ansonsten ...
SUCH1:	DEC	HL
	PUSH	HL
	CALL	FNEXT		;weitersuchen
	POP	HL
	RET	C		;bis kein File mehr
	LD	A,H
	OR	L
	JR	NZ, SUCH1
	RET
;
;File laden
;
FLOAD:	LD	HL,(AADR)	;Ladeadressen
FLOA1:	CALL	BLMK
;
	ld	a,h
	or	l
	ret	z		;bei Eadr 0000 Abbruch (f. ROMs bis FFFFh)
;
	EX	DE,HL
	LD	HL,(EADR)
	OR	A
	SBC	HL,DE
	EX	DE,HL
	JR	NC, FLOA1	;bis Fileende
	RET
;
;erstes File suchen
;
FFIRST:	ld	hl,0
	ld	(FILNR),hl
	call	home
	jp	FNEXT
;
;Eingabe der Filenummer
;
INNR:	;PUSH	HL
	PUSH	DE
	PUSH	BC
INNR1:	DW	PRST7
	DB	CR
	DB	"Nr"
	DB	0BAH	;":"
INNRA:	LD	HL,(CUPOS)
	LD	(SOIL),HL
INNR2:	DW	INCH		;Tastatureingabe
	CP	A, 3		;<STOP>?
	SCF
	JR	Z, INNR3	;ja --> Abbruch
	DW	OUTCH		;Zeichenausgabe
	CP	A, CR		;<ENTER>?
	JR	NZ, INNR2	;nein --> weiter eingeben
;
	LD	HL,0		;Startwert fuer DZKON
	LD	DE,(SOIL)
	CALL	DZKON		;Zahlenkonvertierung
	ld	a, 4
	cp	h		;ok, 1024
	JR	NC, INNR3	;war ok
;
	DW	PRST7		;sonst Fehlermeldung
	DB	"<999!"
	DB	0A0H
	JR	INNR1		;und Neueingabe
;
INNR3:	POP	BC
	POP	DE
	;POP	HL
	RET
;
;Eingabe von Typ+Name
;
INKPF:	LD 	A,IYU
	OR	A		;Typabfrage?
	JR	NZ, INKP2	;wenn nicht noetig
;
	DW	PRST7
	DB	CR
	DB	"typ"
	DB	0BAH		;":"
	DW	INCH		;Tastatureingabe
	CP	A, ' '
	JR	NC, INKP1	;wenn Steuerzeichen
	CP	A, 3		;<STOP>?
	SCF
	RET	Z		;ja --> Abbruch
;
	LD	A,' '		;Steuerzeichen als Typ " "
INKP1:	DW	OUTCH		;Typ anzeigen
	LD 	IYU,A		;und merken
;
INKP2:	DW	PRST7
	DB	" filename"
	DB	0BAH		;":"
	LD	HL,(CUPOS)
	LD	(SOIL),HL
	LD	C,0FFH		;C=Zeichenzaehler
INKP3:	INC	C
	DW	INCH		;Zeicheneingabe
	SCF
	CP	A, 3		;<STOP>?
	RET	Z		;ja --> Abbruch
	CP	A, 8		;Cursor links?
	JR	NZ, INKP5
	DEC	C		;wenn ja, zurueckgehen
	JP	M, INKP3
INKP4:	DEC	C
INKP5:	DW	OUTCH		;Buchstabe anzeigen
	CP	A, CR		;<ENTER>?
	LD	A,C		;Namenslaenge  merken
	LD	(NAMLN),A
	RET	Z		;und zurueck
;
	LD	A,10H		;max. Buchstabenanzahl
	CP	A, C		;erreicht?
	LD	A,8		;ja --> Zeilenende
	JR	NZ, INKP3
	JR	INKP4
;
;Suchen File nach Typ+Name
;
FIND:	CALL	FFIRST
	CALL	C, NOFIL	;Fehlermeldung, wenn kein
	RET	C		;File und Abbruch
;
	LD	HL,NAMLN
	LD	(HL),0		;Namenslaenge =0
	DEC	HL
	LD	(HL),1		;1. File anwaehlen
;
	CALL	INKPF		;Eingabe Typ und Namen
;
FIND1:	LD 	A,IYU
	CP	A, '!'
	JR	C, FIND2	;wenn Typ Steuerzeichen
;
	LD	HL,TYP		;sonst Typvergleich
	CP	A, (HL)
	JR	NZ, FIND5	;wenn ungleich
;
FIND2:	LD	A,(NAMLN)	;eingeg. Namenslaenge
	LD	B,A
	OR	A
	JR	Z, FIND4	;wenn =0
;
	LD	HL,NAME		;sonst Namensvergleich
	LD	DE,(SOIL)
FIND3:	LD	A,(DE)
	CP	A, (HL)
	INC	HL
	INC	DE
	JR	NZ, FIND5	;wenn ungleich
	DJNZ	FIND3
;
FIND4:	LD	HL,(FILNR)	;Filenummer uebergeben
	LD	A,H
	OR	L		;=0 ?
	RET
;
FIND5:	CALL	FNEXT
	CALL	C, FNOTX	;es ex. kein weiteres File
	RET	C
	LD	HL,FILNR	;naechstes File
	INC	(HL)
	JR	FIND1		;und weitersuchen
;
;Konvertierung ASCII (dez.) --> hex
;
DZKON:	LD	A,(DE)		;Zeichen holen
	INC	DE
	CP	A, ' '
	JR	Z, DZKO1
	CP	','
	JR	Z, DZKO1	;SPACE oder "," beenden Zahl
	SUB	30H		;ASCII-Korrektur
;
	LD	B,H
	LD	C,L
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,BC
	ADD	HL,HL
	LD	B,0
	LD	C,A
	ADD	HL,BC		;HL=HL*10+Zahl
	JR	DZKON		;und naechste Ziffer
;
DZKO1:	RET
;
;Schreiben der Fileangaben nach (DE)
;
STFIL:	LD	DE,STPUF
	ld	a,3
	CALL	NRKON		;Schreiben Filenummer A
	CALL	STADR		;Schreiben der Adressen
	LD	A,CR
	LD	(DE),A		;neue Zeile
	INC	DE
;
	LD	B,4		;4 Leerzeichen
	LD	A,' '
STFI1:	LD	(DE),A
	INC	DE
	DJNZ	STFI1
;
	CALL	STNAM		;Filetyp und -name
	LD	A,CR
	LD	(DE),A
;
	XOR	A		;Abschlussbyte
	INC	DE
	LD	(DE),A
	RET
;
;Stringausgabe ab (DE) bis Nullbyte
;
OSTRG:	LD	A,(DE)
	INC	DE
	OR	A
	RET	Z
	DW	OUTCH
	JR	OSTRG
;
;Schreiben von TYP und NAME nach (DE)
;
STNAM:	LD	A,(TYP)
	LD	(DE),A
	INC	DE
	LD	A,' '
	LD	(DE),A
	INC	DE
	LD	HL,NAME
	LD	BC,0010H
	LDIR
	RET
;
;Schreiben von AADR, EADR, SADR nach (DE)
;
STADR:	LD	B,3
	LD	IX,AADR
STAD1:	LD	A,' '
	LD	(DE),A
	INC	DE
	LD	L,(IX+0)
	INC	IX
	LD	H,(IX+0)
	INC	IX
	CALL	HLKON
	DJNZ	STAD1
	RET
;
;Konvertierung HL --> ASCII-hex nach (DE)
;
HLKON:	PUSH	AF
	LD	A,H
	CALL	AKON
	LD	A,L
	CALL	AKON
	POP	AF
	RET
;
;Konvertierung A --> ASCII-hex nach (DE)
;
AKON:	PUSH	AF
	RRA
	RRA
	RRA
	RRA
	CALL	AKON1
	POP	AF
AKON1:	PUSH	AF
	AND	A, 0FH
	ADD	A, 30H
	CP	A, ':'
	JR	C, AKON2
	ADD	A, 7
AKON2:	LD	(DE),A
	INC	DE
	POP	AF
	RET
;
;Konvertieren Filenummer
;HL->(DE) dez.
nrkon	push	bc
	push	hl
	cp	2
	jr	z,nrkon2
;	ld	bc,-10000
;	call	Num1
;	ld	bc,-1000
;	call	Num1
nrkon3	ld	bc,-100
	call	Num1
nrkon2	ld	bc,-10
	call	Num1
	ld	c,-1
	call	Num1
	pop	hl
	pop	bc
	ret
Num1	ld	a,'0'-1
Num2	inc	a
	add	hl,bc
	jr	c,Num2
	sbc	hl,bc
	ld	(de),a
	inc	de
	ret


;
;Eintragen der Filelaenge
;
FLLEN:	PUSH	DE
	LD	DE,(AADR)
	LD	HL,(EADR)
	XOR	A
	SBC	HL,DE		;Filelaenge
	SRL	H
	RR	L
	SRL	H
	RR	L		;Filelaenge/4
;
	OR	L		;L=0?
	JR	Z, FLLE1
	INC	H		;sonst aufrunden
FLLE1:	LD	L,H		;HL=Filelaenge in Kbyte
	LD	H,0
	POP	DE
;
	ld	a, ' '
	ld	(de), a
	inc	de

	ld	a,2
	CALL	NRKON		;nach (DE) schreiben
	LD	A,'K'		;"Kbyte"
	LD	(DE),A
	INC	DE
	RET
;
;Fehlermeldungen
;
DISKF:	PUSH	AF
	DW	PRST7
	DB	" disk full!"
	DB	80H+CR
	JR	ERR
;
FNOTX:	PUSH	AF
	DW	PRST7
	DB	" file does not exist"
	DB	80H+CR
	JR	ERR
;
NOFIL:	PUSH	AF
	DW	PRST7
	DB	" no files"
	DB	80H+CR
;
ERR:	POP	AF
	RET
;
NOSAV:	PUSH	AF
	DW	PRST7
	DB	" read only disk!"
	DB	80H+CR
	JR	ERR

;
;**************************************
;Zusatzmonitorrufe initialisieren
;**************************************
;
ZMIN0:	LD	HL,USRKD
ZMIN1:	LD	A,(HL)
	OR	A
	JR	Z, ZMIN2
	CP	A, 'W'		; erstes eigenes Kommando0
	JR	Z, ZMIN2
	INC	HL
	INC	HL
	INC	HL
	JR	ZMIN1
;
ZMIN2:	LD	DE,KDOTB
	EX	DE,HL
	LD	BC,KDOTBEND-KDOTB	;Tabellenlaenge
	LDIR
	RET
;
ZMINI:	CALL	ZMIN0
;;	CALL	FILES
	RST	38H
;
;Kommandotabelle
;
KDOTB:	DB	"W"
	DW	WRITE
	DB	"R"
	DW	READ
	DB	"F"
	DW	FILES
;
KDOTBEND:	equ $

;**************************************
; phys. Disk-Treiber
;**************************************
;
; die Disk wird so angesteuert,
; als wre sie aus Sektoren von 20h Byte gebaut
; BANK:	ds 	1		;Banknr.
; DSKPOS:ds	2		;aktuelle Pos. in Disk
;
;naechsten Sektor angesteuern
;
NXSEC:	ld	hl,(DSKPOS)
	ld	de,0020h
	add	hl,de
	ld	(DSKPOS), hl
	;
	LD	de, 0e800h
	ex	hl,de
	OR	A		;Cy=0
	sbc	hl,de
	RET	NZ		;keine Bankumschaltung noetig
;
	LD	A,(BANK)
	INC	A		;naechste Bank auswaehlen
	OR	A		;Cy=1, wenn Ueberlauf
	SCF
	RET	Z		; A > 255, d.h. A=0
	ccf
	jr	home1
;
;Diskette in Grundstellung bringen
;
HOME:	LD	A,0
home1:	ld	(BANK),a
	ld	hl, 0c000h
	ld	(DSKPOS), hl
	jr	SETBANK1
;
;aktuelle Bank in Disk selektieren
;
SETBANK:	LD	A,(BANK)
SETBANK1:	OUT	bankport, A
		RET
;
;**************************************
; logischer Disk-Treiber
;**************************************
;
;Block lesen
;in HL: Zieladr.
;
BLMK:	CALL	SETBANK		;anfahren
	LD	DE,(DSKPOS)
	LD	BC,20H		;20 Byte
	ex	de,hl
	LDIR			;transportieren
	push	de
	CALL	NXSEC		;neuer Sektor
	pop	hl
	RET
;
;nchstes File suchen
;
FNEXT0:	CALL	NXSEC
	RET	C		;Diskende
FNEXT:	CALL	SETBANK		;Position ausgeben
	LD	HL,(DSKPOS)
	LD	A, L
	ADD	A, 0DH
	LD	L,A
;Test, ob hier ein Kopfblock steht
	LD	B,3		;3 Zeichen
FNEXT1:	LD	A,(HL)
	INC	HL
	CP	A, 0D3H		;Kopfblocksigns
	JR	NZ, FNEXT0	;wenn nicht gefunden, dann nchsten Sektor
	DJNZ	FNEXT1		;sonst Kopf weitertesten
;
	LD	HL,AADR
	CALL	BLMK		;(Kopfblock)
	RET

;**************************************

RAM	equ	$

	DB	"V. Pohlers ",DATE

	phase	RAM

;
;HDISK-Notizspeicher
;
BANK:	ds 	1		;Banknr.
DSKPOS:	ds	2		;Fensterbereich
;
FILNR:	ds	2		;Fileanzahl
NAMLN:	ds	1
;
STPUF:	ds	20
;

	dephase

; Mini-Sprungverteiler f. Patches in den Programmen
	org	0C000h-3*6

	JP	NOSAV		;BFEE AKP	Kopfpuffer aufbereiten	-> FFBE	S
	JP	NOSAV		;BFF1 BSMK	Block schreiben		-> FFC4	S
	JP	NOSAV		;BFF4 SARUF	Headersave		-> FFF4	S
	JP	SUCHK		;BFF7 SUCHK	Kopfblock suchen	-> FFC1 L
	JP	BLMK		;BFFA BLMK	Block lesen		-> FFC7 L
	JP	LORUF		;BFFD LORUF	Headerload		-> FFF1 L

	END
