	cpu	z80
	;PN	EXREASS	

;Reassembler fuer Z1013 auf Basis des
;robotron-Reassemblers REASS 1.01
;Volker Pohlers, 2200 Greifswald, Lomonossowalee 41/81

SOIL:	EQU	00016H	
ARG1:	EQU	0001BH	
CUPOS:	EQU	0002BH	

	ORG	0B000H	

	DB	0E7H	
	DB	2	
	DB	0DH	
	DB	"Z1013 REASS 2.02 VP"	
	DB	27H	
	DB	"88"	
	DB	0DH	
	DB	0DH	
	DB	"A    - Adresswort"	
	DB	0DH	
	DB	"B    - Datenbyte"	
	DB	0DH	
	DB	"T    - Textbyte"	
	DB	0DH	
	DB	"N    - neue Adresse"	
	DB	0DH	
	DB	"M    - Modify"	
	DB	0DH	
	DB	"STOP - Ende"	
	DB	0DH	
	DB	"Rest - Reassemblieren"	
	DB	8DH	

REAS0:	RST	20H	
	DB	2	
	DB	0DH	
	DB	0DH	
	DB	"ab   ORG-Adresse:"	
	DB	0DH	
	DB	8DH	
	RST	20H	
	DB	10H	
	LD	DE,(SOIL)	
	RST	20H	
	DB	3	
	LD	(ADR),HL	
	LD	(OADR),HL	
	RST	20H	
	DB	3	
	LD	A,H	
	OR	L	
	JR	Z, REAS1	
	LD	(OADR),HL	

REAS1:	LD	HL,(ADR)	
	CALL	CODE	
	CALL	HEX1		;Ausg. Adr., 1 Byte
	RST	20H	
	DB	1	
	CP	A, 'A'	
	JR	Z, ADRO	
	CP	A, 'B'	
	JR	Z, BYTE	
	CP	A, 'T'	
	JR	Z, TEXT	
	CP	A, 'N'	
	JR	Z, REAS0	
	CP	A, 'M'	
	JR	Z, MEMO	
	CP	A, 3		;<STOP>
	JP	Z, 0038H		;RST7

	CALL	HEX2		;Rest ausgeben
	CALL	RECO	
REAS2:	CALL	NEXT	
	JR	REAS1	

ADRO:	LD	A,2		;Ausg. als Adr.
	LD	(LAEN),A	
	CALL	HEX2	
	RST	20H	
	DB	2	
	DB	"DA  "	
	DB	0A0H	
	LD	HL,(ADR)	
	LD	A,(HL)	
	INC	HL	
	LD	H,(HL)	
	LD	L,A	
	RST	20H	
	DB	7		;OUTHL
	JR	REAS2	

TEXT:	LD	A,1		;Ausg. Textbyte
	LD	(LAEN),A	
	CALL	HEX2	
	LD	A,1	
	CALL	STRUP	
	JR	REAS2	

BYTE:	LD	A,1		;Ausg. als Byte
	LD	(LAEN),A	
	CALL	HEX2	
	RST	20H	
	DB	2	
	DB	"DB  "	
	DB	0A0H	
	LD	HL,(ADR)	
	LD	A,(HL)	
	RST	20H	
	DB	6		;OUTHX
	JR	REAS2	

MEMO:	LD	A,0DH	
	RST	20H	
	DB	0	
	LD	HL,(ADR)	
	LD	(ARG1),HL	
	RST	20H	
	DB	0AH		;MEM
	JR	REAS1	

HEX1:	LD	(LAEN),A	
	LD	HL,(CUPOS)	
	LD	(CURS),HL	
	LD	HL,(OADR)	
	RST	20H	
	DB	7		;Ausg. Adr.
	RST	20H	
	DB	0EH	
	LD	HL,(ADR)	
	LD	A,(HL)	
	RST	20H	
	DB	6		;Ausg. 1 Byte
	RST	20H	
	DB	0EH	
	RET		

HEX2:	LD	A,(LAEN)	
	DEC	A	
	LD	D,A	
	LD	E,0AH	
	JR	Z, MHEX2	
	LD	HL,(ADR)	
MHEX1:	INC	HL	
	LD	A,(HL)	
	RST	20H	
	DB	6		;Ausg. Bytes
	RST	20H	
	DB	0EH	
	DEC	E	
	DEC	E	
	DEC	E	
	DEC	D	
	JR	NZ, MHEX1	
MHEX2:	DEC	E	
	RET	Z	
	RST	20H	
	DB	0EH		;OSPAC
	JR	MHEX2	

NEXT:	LD	HL,(ADR)	;Zaehler erhoehen
	LD	D,0	
	LD	A,(LAEN)	
	LD	E,A	
	ADD	HL,DE	
	LD	(ADR),HL	
	LD	HL,(OADR)	
	ADD	HL,DE	
	LD	(OADR),HL	
	LD	A,0DH	
	RST	20H	
	DB	0	
	RET		
RECO:	LD	HL,(ADR)	
	LD	A,(HL)	
	CP	A, 0E7H		;RST 20H-Befehl ?
	JR	Z, EXRS1	
	CALL	RECOD	
	RET		

EXRS1:	INC	HL	
	LD	A,(HL)	
	PUSH	AF	
	RST	20H	
	DB	2	
	DB	"DA  "	
	DB	0A0H	
	POP	AF	
	PUSH	AF	
	LD	E,A	
	LD	D,0	
	LD	HL,EXTAB	
	LD	B,5	
EXRS2:	ADD	HL,DE	
	DJNZ	EXRS2	
	LD	B,5	
EXRS3:	LD	A,(HL)	
	RST	20H	
	DB	0		;Ausg. Name
	INC	HL	
	DJNZ	EXRS3	
	POP	AF	
	CP	A, 2		;PRST7 ?
	RET	NZ	

STR3:	CALL	NEXT	
	LD	HL,(ADR)	
	LD	B,4	
STR1:	LD	A,(HL)	
	CP	A, 80H	
	JR	NC, STR2	
	INC	HL	
	DJNZ	STR1	

	LD	A,4	
	CALL	HEX1	
	RST	20H	
	DB	1	
	CALL	HEX2	
	LD	A,4	
	CALL	STRUP		;Ausg. Text
	JR	STR3	

STR2:	LD	A,5	
	SUB	B	
	PUSH	AF	
	CALL	HEX1	
	RST	20H	
	DB	1	
	CALL	HEX2	
	POP	AF	
	CALL	STRUP	
	RET		

STRUP:	PUSH	AF	
	RST	20H	
	DB	2	
	DB	"DB   "	
	DB	0A7H	
	POP	BC		;B:=A
	LD	HL,(ADR)	
STRU2:	LD	A,(HL)	
	AND	A, 7FH	
	CP	A, ' '	
	JR	NC, STRU1	
	LD	A,'.'	
STRU1:	RST	20H	
	DB	0	
	INC	HL	
	DJNZ	STRU2	
	LD	A,27H	
	RST	20H	
	DB	0	
	RET		

EXTAB:	DB	"OUTCHINCH PRST7INHEXINKEYINLIN"	
	DB	"OUTHXOUTHLCSAVECLOADMEM  WIND "	
	DB	"OTHLSOUTDPOUTSPTRANSINSTRKILL "	
	DB	"HEXUMALFA "	

;Original-Riesa-Reassembler :

CODE:	LD	A,(HL)	
	CP	A, 0DDH	
	JR	Z, M372D	
	CP	A, 0EDH	
	JP	Z, M376A	
	CP	A, 0FDH	
	JR	Z, M372D	
	AND	A, 0F0H	
	CP	A, '@'	
	JR	C, M3701	
	CP	A, 0C0H	
	JR	C, M3729	
	LD	A,(HL)	
	CP	A, 0E7H	
	JR	Z, M3725	
	AND	A, 3FH	
	CP	A, 0DH	
	JR	Z, M3721	
	CP	A, 3	
	JR	Z, M3721	
	CP	A, 0BH	
	JR	Z, M3725	
	AND	A, 37H	
	CP	A, 13H	
	JR	Z, M3725	
	AND	A, 0FH	
	CP	A, 2	
	JR	Z, M3721	
	CP	A, 4	
	JR	Z, M3721	
	CP	A, 6	
	JR	Z, M3725	
	JR	M3729	
M3701:	LD	A,(HL)	
	AND	A, 0FH	
	CP	A, 1	
	JR	Z, M3721	
	LD	A,(HL)	
	AND	A, 37H	
	JR	Z, M371B	
	AND	A, 2FH	
	CP	A, '"'	
	JR	Z, M3721	
	AND	A, 0FH	
	JR	Z, M3725	
	CP	A, 6	
	JR	Z, M3725	
M371B:	JR	M3729	
M371D:	LD	A,4	
	JR	M372B	
M3721:	LD	A,3	
	JR	M372B	
M3725:	LD	A,2	
	JR	M372B	
M3729:	LD	A,1	
M372B:	LD	B,A	
	RET		
M372D:	INC	HL	
	LD	A,(HL)	
	CP	A, '!'	
	JR	Z, M371D	
	CP	A, '"'	
	JR	Z, M371D	
	CP	A, '6'	
	JR	Z, M371D	
	CP	A, '*'	
	JR	Z, M371D	
	CP	A, '+'	
	JR	Z, M3725	
	CP	A, '4'	
	JR	Z, M3721	
	CP	A, '5'	
	JR	Z, M3721	
	CP	A, 0CBH	
	JR	Z, M371D	
	CP	A, '|'	
	JR	Z, M3725	
	CP	A, '$'	
	JR	Z, M3725	
	CP	A, '}'	
	JR	Z, M3725	
	AND	A, 0F0H	
	CP	A, 'p'	
	JR	Z, M3721	
	LD	A,(HL)	
	AND	A, 7	
	CP	A, 6	
	JR	Z, M3721	
	JR	M3725	
M376A:	INC	HL	
	LD	A,(HL)	
	CP	A, 80H	
	JR	NC, M3725	
	AND	A, 7	
	CP	A, 3	
	JR	Z, M371D	
	JR	M3725	
M3778:	LD	A,(HL)	
	RST	20H	
	DB	0	
	INC	HL	
	LD	A,(HL)	
	RST	20H	
	DB	0	
	INC	HL	
	LD	A,(HL)	
	RST	20H	
	DB	0	
	INC	HL	
	LD	A,(HL)	
	RST	20H	
	DB	0	
	RST	20H	
	DB	0EH	
	RET		
M378A:	DB	"HALT"	
M378E:	DB	"LD  "	
M3792:	DB	"ADD "	
M3796:	DB	"ADC SUB "	
M379E:	DB	"SBC AND XOR OR  CMP "	
M37B2:	DB	"PUSH"	
M37B6:	DB	"POP "	
M37BA:	DB	"RST "	
M37BE:	DB	"JMP "	
M37C2:	DB	"EXX "	
M37C6:	DB	"OUT "	
M37CA:	DB	"IN  "	
M37CE:	DB	"EX  EX  DI  EI  "	
M37DE:	DB	"(SP),HL"	
	DB	0	
M37E6:	DB	"DE,HL"	
	DB	0	
M37EC:	DB	"SP,HL"	
	DB	0	
M37F2:	DB	"INC "	
M37F6:	DB	"DEC "	
M37FA:	DB	"RLCARRCARLA RRA DAA CPL SCF CCF "	
M381A:	DB	"NOP EXAFDJNZJR  JRNZJRZ JRNCJRC "	
M383A:	DB	"(BC)"	
M383E:	DB	"(DE)"	
M3842:	DB	"RLC RRC RL  RR  SLA SRA SLL SRL "	
M3862:	DB	"BIT "	
M3866:	DB	"RES "	
M386A:	DB	"SET "	
M386E:	DB	"(SP)"	
M3872:	DB	"    NEG RETNIM 0RETIIM 1    IM 2"	
M3892:	DB	"RRD RLD "	
M389A:	DB	"I,A R,A A,I A,R "	
M38AA:	DB	"LDI CPI INI OUTILDIRCPIRINIROTIRLD"	
	DB	"D CPD IND OUTDLDDRCPDRINDROTDR OUT"	
	DB	"CHCAR LR  "	
M38F8:	SLA	A	
	ADD	A, L	
	LD	L,A	
	LD	A,H	
	ADC	A, 0	
	LD	H,A	
	LD	A,(HL)	
	RST	20H	
	DB	0	
	INC	HL	
	LD	A,(HL)	
	OR	A	
	RET	Z	
	RST	20H	
	DB	0	
	RET		
M390A:	LD	HL,M3923	
	JR	M38F8	
M390F:	LD	HL,M3933	
	JR	M38F8	
M3914:	LD	HL,M393B	
	JR	M38F8	
M3919:	LD	HL,M394B	
	JR	M38F8	
M391E:	LD	HL,M395D	
	JR	M38F8	
M3923:	DB	"B"	
	DB	0	
	DB	"C"	
	DB	0	
	DB	"D"	
	DB	0	
	DB	"E"	
	DB	0	
	DB	"H"	
	DB	0	
	DB	"L"	
	DB	0	
	DB	"M"	
	DB	0	
	DB	"A"	
	DB	0	
M3933:	DB	"BCDEHLAF"	
M393B:	DB	"NZZ NCC POPEP M "	
M394B:	DB	" RETJPJR"	
M3953:	DB	"CALL-$A,,A"	
M395D:	DB	"BCDEHLSP"	
M3965:	EXX		
	RET		
M3967:	LD	A,(IY+0)	
	AND	A, 38H	
	RRCA		
	RRCA		
	RRCA		
	AND	A, 7	
	RET		
M3972:	CALL	M3967	
	RRCA		
	AND	A, 3	
	RET		
M3979:	LD	A,B	
	RST	20H	
	DB	6	
	LD	A,C	
	RST	20H	
	DB	6	
	RET		
M3980:	LD	A,','	
	RST	20H	
	DB	0	
	RET		
RECOD:	EXX		
	LD	IY,(ADR)	
	LD	A,(IY+0)	
	CP	A, '@'	
	JP	C, M3B0E	
	CP	A, 80H	
	JR	C, M399C	
	CP	A, 0C0H	
	JR	C, M39C4	
	JR	M39DE	
M399C:	CP	A, 'v'	
	JR	Z, M39BB	
	LD	HL,M378E	
	CALL	M3778	
	CALL	M3967	
	CALL	M390A	
	LD	A,','	
	RST	20H	
	DB	0	
	LD	A,(IY+0)	
	AND	A, 7	
	CALL	M390A	
	JP	M3965	
M39BB:	LD	HL,M378A	
	CALL	M3778	
	JP	M3965	
M39C4:	AND	A, 38H	
	RRCA		
	LD	HL,M3792	
	ADD	A, L	
	LD	L,A	
	LD	A,H	
	ADC	A, 0	
	LD	H,A	
	CALL	M3778	
	LD	A,(IY+0)	
	AND	A, 7	
	CALL	M390A	
	JP	M3965	
M39DE:	CP	A, 0CBH	
	JP	Z, M3C76	
	CP	A, 0DDH	
	JP	Z, M3CFC	
	CP	A, 0EDH	
	JP	Z, M3EE8	
	CP	A, 0FDH	
	JP	Z, M3D00	
	CP	A, 0CDH	
	JP	Z, M3A68	
	AND	A, 7	
	JP	Z, M3A7F	
	CP	A, 6	
	JR	Z, M3A35	
	CP	A, 7	
	JR	Z, M3A4F	
	CP	A, 4	
	JP	Z, M3A70	
	CP	A, 2	
	JP	Z, M3A8D	
	LD	A,(IY+0)	
	AND	A, 0FH	
	CP	A, 1	
	JR	Z, M3A2D	
	CP	A, 5	
	JR	Z, M3A1E	
	JP	M3AA1	
M3A1E:	LD	HL,M37B2	
	CALL	M3778	
M3A24:	CALL	M3972	
	CALL	M390F	
	JP	M3965	
M3A2D:	LD	HL,M37B6	
	CALL	M3778	
	JR	M3A24	
M3A35:	LD	A,(IY+0)	
	AND	A, 38H	
	RRCA		
	LD	HL,M3792	
	ADD	A, L	
	LD	L,A	
	LD	A,H	
	ADC	A, 0	
	LD	H,A	
	CALL	M3778	
	LD	A,(IY+1)	
	RST	20H	
	DB	6	
	JP	M3965	
M3A4F:	LD	HL,M37BA	
	CALL	M3778	
	CALL	M3972	
	ADD	A, 30H	
	RST	20H	
	DB	0	
	LD	A,(IY+0)	
	AND	A, 8	
	ADD	A, 30H	
	RST	20H	
	DB	0	
	JP	M3965	
M3A68:	LD	HL,M3953	
	CALL	M3778	
	JR	M3A91	
M3A70:	LD	A,4	
M3A72:	CALL	M3919	
	CALL	M3967	
	CALL	M3914	
	RST	20H	
	DB	0EH	
	JR	M3A91	
M3A7F:	LD	A,0	
	CALL	M3919	
	CALL	M3967	
	CALL	M3914	
	JP	M3965	
M3A8D:	LD	A,2	
	JR	M3A72	
M3A91:	LD	C,(IY+1)	
	LD	B,(IY+2)	
	LD	(M3FDA),BC	
	CALL	M3979	
	JP	M3965	
M3AA1:	LD	DE,0	
	AND	A, 7	
	CP	A, 3	
	JR	NZ, M3ADD	
	CALL	M3967	
	PUSH	AF	
	LD	HL,M37BE	
	CALL	M3F34	
	EXX		
	POP	AF	
	CP	A, 0	
	JR	Z, M3A91	
	CP	A, 4	
	JR	C, M3AC7	
	JR	Z, M3ACF	
	CP	A, 5	
	JR	Z, M3AD8	
	JP	M3965	
M3AC7:	LD	A,(IY+1)	
	RST	20H	
	DB	6	
	JP	M3965	
M3ACF:	LD	HL,M37DE	
M3AD2:	CALL	M3FD0	
	JP	M3965	
M3AD8:	LD	HL,M37E6	
	JR	M3AD2	
M3ADD:	CALL	M3972	
	JR	Z, M3AF3	
	CP	A, 2	
	JR	C, M3AFC	
	JR	Z, M3B01	
	LD	HL,M378E	
	CALL	M3778	
	LD	HL,M37EC	
	JR	M3AD2	
M3AF3:	LD	HL,M394B	
M3AF6:	CALL	M3778	
	JP	M3965	
M3AFC:	LD	HL,M37C2	
	JR	M3AF6	
M3B01:	LD	HL,M37BE	
	CALL	M3778	
	LD	A,'M'	
	RST	20H	
	DB	0	
	JP	M3965	
M3B0E:	AND	A, 0FH	
	CP	A, 3	
	JR	Z, M3B37	
	CP	A, 0BH	
	JR	Z, M3B46	
	AND	A, 7	
	JR	Z, M3B77	
	CP	A, 2	
	JP	C, M3BA7	
	JP	Z, M3BE6	
	CP	A, 5	
	JR	C, M3B4B	
	JR	Z, M3B5A	
	CP	A, 7	
	JR	C, M3B5F	
	LD	HL,M37FA	
M3B31:	CALL	M3967	
	JP	M3F34	
M3B37:	LD	HL,M37F2	
M3B3A:	CALL	M3778	
	CALL	M3972	
	CALL	M391E	
	JP	M3965	
M3B46:	LD	HL,M37F6	
	JR	M3B3A	
M3B4B:	LD	HL,M37F2	
M3B4E:	CALL	M3778	
	CALL	M3967	
	CALL	M390A	
	JP	M3965	
M3B5A:	LD	HL,M37F6	
	JR	M3B4E	
M3B5F:	LD	HL,M378E	
	CALL	M3778	
	CALL	M3967	
	CALL	M390A	
	LD	A,','	
	RST	20H	
	DB	0	
	LD	A,(IY+1)	
	RST	20H	
	DB	6	
	JP	M3965	
M3B77:	LD	HL,M381A	
	CALL	M3B31	
	EXX		
	CALL	M3967	
	CP	A, 2	
	JP	C, M3965	
	XOR	A	
	LD	B,A	
	LD	C,(IY+1)	
	BIT	7,C	
	JR	Z, M3B90	
	DEC	B	
M3B90:	LD	HL,(OADR)	
	ADD	HL,BC	
	PUSH	HL	
	POP	BC	
	INC	BC	
	INC	BC	
	LD	(M3FDA),BC	
	CALL	M3979	
	LD	A,6	
	CALL	M3919	
	JP	M3965	
M3BA7:	CALL	M3967	
	BIT	0,A	
	JR	Z, M3BC8	
	RRCA		
	AND	A, 3	
	PUSH	AF	
	LD	HL,M3792	
	CALL	M3778	
	LD	A,2	
	CALL	M390F	
	LD	A,','	
	RST	20H	
	DB	0	
	POP	AF	
	CALL	M391E	
	JP	M3965	
M3BC8:	RRCA		
	AND	A, 3	
	PUSH	AF	
	LD	HL,M378E	
	CALL	M3778	
	POP	AF	
	CALL	M391E	
	LD	A,','	
	RST	20H	
	DB	0	
	LD	C,(IY+1)	
	LD	B,(IY+2)	
	CALL	M3979	
	JP	M3965	
M3BE6:	LD	HL,M378E	
	CALL	M3778	
	CALL	M3967	
	CP	A, 4	
	JR	NC, M3C27	
	AND	A, A	
	JR	Z, M3C19	
	CP	A, 2	
	JR	Z, M3C14	
	JR	C, M3C0A	
	LD	A,7	
	CALL	M3919	
	LD	HL,M383E	
M3C04:	CALL	M3778	
	JP	M3965	
M3C0A:	LD	A,7	
	CALL	M3919	
	LD	HL,M383A	
	JR	M3C04	
M3C14:	LD	HL,M383E	
	JR	M3C1C	
M3C19:	LD	HL,M383A	
M3C1C:	CALL	M3778	
	LD	A,8	
	CALL	M3919	
	JP	M3965	
M3C27:	LD	B,(IY+2)	
	LD	C,(IY+1)	
	CALL	M3967	
	SUB	4	
	JR	Z, M3C58	
	LD	D,A	
	CP	A, 2	
	JR	Z, M3C67	
	JR	NC, M3C51	
	LD	A,2	
	CALL	M390F	
M3C40:	CALL	M3980	
M3C43:	LD	A,'('	
	RST	20H	
	DB	0	
	CALL	M3979	
	LD	A,')'	
	RST	20H	
	DB	0	
	JP	M3965	
M3C51:	LD	A,7	
	CALL	M390A	
	JR	M3C40	
M3C58:	CALL	M3C43	
	EXX		
	CALL	M3980	
	LD	A,2	
	CALL	M390F	
	JP	M3965	
M3C67:	CALL	M3C43	
	EXX		
	CALL	M3980	
	LD	A,7	
	CALL	M390A	
	JP	M3965	
M3C76:	INC	IY	
	LD	A,(IY+0)	
	CP	A, '@'	
	JR	NC, M3C91	
	LD	HL,M3842	
	CALL	M3B31	
	EXX		
	LD	A,(IY+0)	
	AND	A, 7	
	CALL	M390A	
	JP	M3965	
M3C91:	CP	A, 80H	
	JR	C, M3CA3	
	CP	A, 0C0H	
	JR	C, M3C9E	
	LD	HL,M386A	
	JR	M3CA6	
M3C9E:	LD	HL,M3866	
	JR	M3CA6	
M3CA3:	LD	HL,M3862	
M3CA6:	CALL	M3778	
	CALL	M3967	
	ADD	A, 30H	
	RST	20H	
	DB	0	
	LD	A,','	
	RST	20H	
	DB	0	
	LD	A,(IY+0)	
	AND	A, 7	
	CALL	M390A	
	JP	M3965	
M3CBF:	LD	A,'('	
	RST	20H	
	DB	0	
	LD	A,'I'	
	RST	20H	
	DB	0	
	LD	A,C	
	RST	20H	
	DB	0	
	LD	A,'+'	
	BIT	7,B	
	JR	Z, M3CD8	
	INC	A	
	INC	A	
	RST	20H	
	DB	0	
	LD	A,B	
	CPL		
	JR	M3CDB	
M3CD8:	RST	20H	
	DB	0	
	LD	A,B	
M3CDB:	RST	20H	
	DB	6	
	LD	A,')'	
	RST	20H	
	DB	0	
	RET		
	LD	A,D	
M3CE3:	RST	20H	
	DB	0	
	LD	A,C	
	RST	20H	
	DB	0	
	RET		
M3CE9:	LD	A,'I'	
	JR	M3CE3	
M3CED:	LD	A,'H'	
	JR	M3CE3	
M3CF1:	LD	A,'L'	
	JR	M3CE3	
M3CF5:	RST	20H	
	DB	0EH	
	LD	A,','	
	RST	20H	
	DB	0	
	RET		
M3CFC:	LD	C,'X'	
	JR	M3D02	
M3D00:	LD	C,'Y'	
M3D02:	INC	IY	
	LD	A,(IY+0)	
	LD	B,(IY+1)	
	CP	A, 'v'	
	JP	Z, M3965	
	CP	A, '@'	
	JP	C, M3DF5	
	CP	A, 80H	
	JP	C, M3DC2	
	CP	A, 0C0H	
	JP	C, M3D9C	
	CP	A, 0CBH	
	JR	Z, M3D84	
	CP	A, 0E1H	
	JR	Z, M3D39	
	CP	A, 0E3H	
	JR	Z, M3D49	
	CP	A, 0E5H	
	JR	Z, M3D3E	
	CP	A, 0E9H	
	JR	Z, M3D5D	
	CP	A, 0F9H	
	JR	Z, M3D70	
M3D36:	JP	M3965	
M3D39:	LD	HL,M37B6	
	JR	M3D41	
M3D3E:	LD	HL,M37B2	
M3D41:	CALL	M3778	
	CALL	M3CE9	
	JR	M3D36	
M3D49:	LD	HL,M37CE	
	CALL	M3778	
	LD	HL,M386E	
	CALL	M3778	
	CALL	M3CF5	
	CALL	M3CE9	
	JR	M3D36	
M3D5D:	LD	HL,M37BE	
	CALL	M3778	
	LD	A,'('	
	RST	20H	
	DB	0	
	CALL	M3CE9	
	LD	A,')'	
	RST	20H	
	DB	0	
	JR	M3D36	
M3D70:	LD	HL,M378E	
	CALL	M3778	
	LD	A,3	
	CALL	M391E	
	LD	A,','	
	RST	20H	
	DB	0	
	CALL	M3CE9	
	JR	M3D36	
M3D84:	INC	IY	
	LD	A,(IY+1)	
	AND	A, 7	
	CP	A, 6	
	JP	NZ, M3965	
	CALL	M3C76	
	CALL	M3980	
	CALL	M3CBF	
	JP	M3965	
M3D9C:	LD	HL,M3792	
	CALL	M3B31	
	EXX		
	LD	A,(IY+0)	
	AND	A, 7	
	CP	A, 4	
	JR	Z, M3DB8	
	CP	A, 5	
	JR	Z, M3DBD	
	CP	A, 6	
	CALL	Z, M3CBF	
M3DB5:	JP	M3965	
M3DB8:	CALL	M3CED	
	JR	M3DB5	
M3DBD:	CALL	M3CF1	
	JR	M3DB5	
M3DC2:	LD	HL,M378E	
	CALL	M3778	
	CALL	M3967	
	CP	A, 6	
	JR	Z, M3DD7	
	CALL	M390A	
	CALL	M3967	
	JR	M3DDD	
M3DD7:	CALL	M3CBF	
	CALL	M3980	
M3DDD:	LD	A,(IY+0)	
	AND	A, 7	
	CP	A, 6	
	JR	Z, M3DEC	
	CALL	M390A	
	JP	M3965	
M3DEC:	CALL	M3980	
	CALL	M3CBF	
	JP	M3965	
M3DF5:	AND	A, 0FH	
	CP	A, 9	
	JP	Z, M3EC8	
	LD	A,(IY+0)	
	CP	A, '!'	
	JP	C, M3965	
	JP	Z, M3EB0	
	AND	A, 0FH	
	CP	A, 3	
	JP	Z, M3EA4	
	CP	A, 0BH	
	JP	Z, M3E9F	
	AND	A, 7	
	CP	A, 4	
	JR	Z, M3E87	
	CP	A, 5	
	JR	Z, M3E82	
	LD	HL,M378E	
	CALL	M3778	
	LD	A,(IY+0)	
	CP	A, '"'	
	JR	Z, M3E74	
	CP	A, '&'	
	JR	Z, M3E56	
	CP	A, '*'	
	JR	Z, M3E5B	
	CP	A, '.'	
	JR	Z, M3E47	
	CP	A, '6'	
	JR	NZ, M3E53	
	CALL	M3CBF	
	CALL	M3980	
	LD	A,(IY+2)	
	RST	20H	
	DB	6	
	JR	M3E53	
M3E47:	CALL	M3CF1	
M3E4A:	LD	A,','	
	RST	20H	
	DB	0	
	LD	A,(IY+1)	
	RST	20H	
	DB	6	
M3E53:	JP	M3965	
M3E56:	CALL	M3CED	
	JR	M3E4A	
M3E5B:	CALL	M3CE9	
	CALL	M3980	
M3E61:	LD	A,'('	
	RST	20H	
	DB	0	
	LD	C,(IY+1)	
	LD	B,(IY+2)	
	CALL	M3979	
	LD	A,')'	
	RST	20H	
	DB	0	
	JR	M3E53	
M3E74:	PUSH	BC	
	CALL	M3E61	
	EXX		
	POP	BC	
	CALL	M3980	
	CALL	M3CE9	
	JR	M3E53	
M3E82:	LD	HL,M37F6	
	JR	M3E8A	
M3E87:	LD	HL,M37F2	
M3E8A:	CALL	M3778	
	LD	A,(IY+0)	
	CP	A, 27H	
	JP	C, M3DB8	
	CP	A, '0'	
	JP	C, M3DBD	
	CALL	M3CBF	
	JR	M3E53	
M3E9F:	LD	HL,M37F6	
	JR	M3EA7	
M3EA4:	LD	HL,M37F2	
M3EA7:	CALL	M3778	
	CALL	M3CE9	
	JP	M3965	
M3EB0:	LD	HL,M378E	
	CALL	M3778	
	CALL	M3CE9	
	LD	A,','	
	RST	20H	
	DB	0	
	LD	C,(IY+1)	
	LD	B,(IY+2)	
	CALL	M3979	
	JR	M3E53	
M3EC8:	LD	HL,M3792	
	CALL	M3778	
	CALL	M3CE9	
	LD	A,','	
	RST	20H	
	DB	0	
	CALL	M3972	
	CP	A, 2	
	JR	Z, M3EE2	
	CALL	M391E	
	JP	M3965	
M3EE2:	CALL	M3CE9	
	JP	M3965	
M3EE8:	INC	IY	
	LD	A,(IY+0)	
	CP	A, 80H	
	JP	NC, M3FAE	
	CP	A, '@'	
	JP	C, M3965	
	AND	A, 7	
	JR	Z, M3F56	
	CP	A, 1	
	JR	Z, M3F6E	
	LD	A,(IY+0)	
	AND	A, 0FH	
	CP	A, 3	
	JP	Z, M3F8F	
	JP	C, M3F73	
	CP	A, 0AH	
	JR	Z, M3F78	
	CP	A, 0BH	
	JP	Z, M3F9E	
	LD	A,(IY+0)	
	CP	A, '`'	
	JR	NC, M3F40	
	AND	A, 7	
	CP	A, 7	
	JR	Z, M3F48	
	CALL	M3967	
	LD	B,A	
	AND	A, 1	
	LD	C,A	
	INC	B	
	LD	A,(IY+0)	
	AND	A, 3	
	ADD	A, B	
	ADD	A, C	
	LD	HL,M3872	
M3F34:	RLCA		
	RLCA		
M3F36:	LD	D,0	
	LD	E,A	
	ADD	HL,DE	
	CALL	M3778	
M3F3D:	JP	M3965	
M3F40:	AND	A, 8	
	RRCA		
	LD	HL,M3892	
	JR	M3F36	
M3F48:	LD	HL,M378E	
	CALL	M3778	
	CALL	M3967	
	LD	HL,M389A	
	JR	M3F34	
M3F56:	LD	HL,M37CA	
M3F59:	CALL	M3778	
	CALL	M3967	
	CP	A, 6	
	JR	Z, M3F68	
	CALL	M390A	
	JR	M3F3D	
M3F68:	LD	A,'F'	
	RST	20H	
	DB	0	
	JR	M3F3D	
M3F6E:	LD	HL,M37C6	
	JR	M3F59	
M3F73:	LD	HL,M379E	
	JR	M3F7B	
M3F78:	LD	HL,M3796	
M3F7B:	CALL	M3778	
	LD	A,2	
	CALL	M390F	
	LD	A,','	
	RST	20H	
	DB	0	
M3F87:	CALL	M3972	
	CALL	M391E	
	JR	M3F3D	
M3F8F:	LD	HL,M378E	
	CALL	M3778	
	CALL	M3E61	
	EXX		
	CALL	M3980	
	JR	M3F87	
M3F9E:	LD	HL,M378E	
	CALL	M3778	
	CALL	M3F87	
	EXX		
	CALL	M3980	
	JP	M3E61	
M3FAE:	CP	A, 0A0H	
	JP	C, M3965	
	CP	A, 0BCH	
	JP	NC, M3965	
	AND	A, 7	
	CP	A, 4	
	JP	NC, M3965	
	LD	A,(IY+0)	
	CP	A, 0B0H	
	JR	C, M3FC8	
	ADD	A, 4	
M3FC8:	AND	A, 0FH	
	LD	HL,M38AA	
	JP	M3F34	
M3FD0:	LD	A,(HL)	
	OR	A	
	RET	Z	
	RST	20H	
	DB	0	
	INC	HL	
	JR	M3FD0	
ADR:	DW	0	
M3FDA:	DW	0	
LAEN:	DW	0	
OADR:	DW	0	
CURS:	DW	0	

PEND:	EQU	$	

	END		
