;
;RAM-Zellen
;
R20BT:	EQU	00003H			;Nummer des RST20-Calls
LAKEY:	EQU	00004H			;letztes Zeichen von Tastatur
BPADR:	EQU	0000BH			;Breakpointadresse
BPOPC:	EQU	0000DH			;Operandenfolge bei Breakpoint
DATA:	EQU	00013H			;Adresse bei INHEX; intern f. INKEY b. A2
;SHILO:	EQU	00015H			;
SOIL:	EQU	00016H			;Beginn Eingabezeile
ARG1:	EQU	0001BH			;1. Argument
ARG2:	EQU	0001DH			;2. Argument
BUFFA:	EQU	0001FH			;vom Cursor verdecktes Zeichen
RST20:	EQU	00020H			;RST 20H
ARG3:	EQU	00023H			;3. Argument
SOIL2:	EQU	00025H			;Rest Eingabezeile
CUPOS:	EQU	0002BH			;aktuelle Cursorposition
LSYNC:	EQU	00033H			;Kenntonlaenge
RST38:	EQU	00038H			;RST 38H
WINDL:	EQU	00035H			;Windowlaenge
KYBTS:	equ	00037h			;Tastaturroutinenzelle (Bit 4=Repeat)
WINDA:	EQU	0003BH			;Windowanfang
WINDE:	EQU	0003DH			;Windowende+1
REGBR:	EQU	0004DH			;Registerrettebereich
REGAF:	EQU	0005BH			;Register AF
REGPC:	EQU	00061H			;Register PC
REGSP:	EQU	00063H			;Userstack
NMI:	EQU	00066H
NBYTE:	EQU	00069H			;Operand bei NEXT
SPADR:	EQU	0006AH			;SP-Zwischenspeicher
FBANZ:	EQU	0006CH			;Zwsp. Anz. Suchbytes bei FIND
USRSK:	EQU	00090H			;Userstack
SYSSK:	EQU	000B0H			;Systemstack
USRKD:	EQU	SYSSK
;Bildschirm
BWS:	EQU	0EC00H			;Beginn BWS
BWSROW	EQU	32			;Anzahl Zeilen
BWSCOL	EQU	32			;Anzahl Zeichen/Zeile
BWSSZ	EQU	BWSROW*BWSCOL
;
;Markenvereinbarungen
;
CLS:	EQU	0CH
CR:	EQU	0DH
ESC:	EQU	27
NL:	EQU	1EH
LF:	EQU	0AH
;
;PIO
PIOAD	equ	00h 			; PIO A User
PIOAC	equ	01h
PIOBD	equ	02h			; PIO B, Bit0..4 Tastaturzeile
PIOBC	equ	03h			; Bit5->AB0 in, Bit6->TB in, Bit7->TB out
KEYP	equ	08h			; Port Ausgabe Tastaturspalte
;
; Makros fr Systemaufrufe ber RST 20h
;
ROUTC:	MACRO
	RST	20H
	DB	0			; OUTCH
	ENDM
RINCH:	MACRO
	RST	20H
	DB	01h			; INCH
	ENDM
RPRST:	MACRO
	RST	20H
	DB	02h			; PRST
	ENDM
RINHX:	MACRO
	RST	20H
	DB	03h			; INHEX
	ENDM
RINKY:	MACRO
	RST	20H
	DB	04h			; INKEY
	ENDM
RINLN:	MACRO
	RST	20H
	DB	05h			; INLIN
	ENDM
ROTHX:	MACRO
	RST	20H
	DB	06h			; OUTHX
	ENDM
ROTHL:	MACRO
	RST	20H
	DB	07h			; OUTHL
	ENDM
ROTHS:	MACRO
	RST	20H
	DB	0Ch			; OTHLS
	ENDM
ROTDP:	MACRO
	RST	20H
	DB	0Dh			; OUTDP
	ENDM
ROTSP:	MACRO
	RST	20H
	DB	0Eh			; OUTSP
	ENDM

